#global __os_install_post /usr/lib/rpm/brp-compress
#global __debug_install_post %{nil}
#global debug_package %{nil}

# OpenSSH privilege separation requires a user & group ID
%define sshd_uid    74
%define sshd_gid    74

# Version of ssh-askpass
%define aversion 1.2.4.1

# Do we want to disable building of x11-askpass? (1=yes 0=no)
%define no_x11_askpass 0

# Do we want to disable building of gnome-askpass? (1=yes 0=no)
%define no_gnome_askpass 1

# Do we want to link against a static libcrypto? (1=yes 0=no)
%define static_libcrypto 0

# Do we want smartcard support (1=yes 0=no)
%define scard 1

# Use GTK2 instead of GNOME in gnome-ssh-askpass
%define gtk 1

# Do we want kerberos5 support (1=yes 0=no)
%define kerberos5 1

# Build NERSC Bro-instrumented packages (iSSHD)?
%define nersc 0

# Calculate xauth and imake dependencies
%{expand: %%global breq_xauth %(which xauth 2>/dev/null || echo xauth)}
%{expand: %%global breq_xmkmf %(which xmkmf 2>/dev/null || echo xmkmf)}

%global name openssh
#global rel  0.%(date '+%Y%m%d%H%M').scs%{?dist}
%global rel  3.scs%{?dist}

# Bro vs. Non-Bro stuff
%if %{nersc}
%{expand:%%global name %{name}-nersc}
#{expand:%%global rel  0.%(date '+%Y%m%d%H%M').3.17.nersc.%{rel}}
%{expand:%%global rel  3.17.nersc.%{rel}}
%endif

Summary: The OpenSSH implementation of SSH protocol versions 1 and 2.
Name: %{name}
Version: 7.1p1
Release: %{rel}
License: BSD
Group: Applications/Internet
URL: http://www.openssh.com/portable.html
Source0: ftp://ftp.openbsd.org/pub/OpenBSD/OpenSSH/portable/openssh-%{version}.tar.gz
Source1: ftp://ftp.openbsd.org/pub/OpenBSD/OpenSSH/portable/openssh-%{version}.tar.gz.asc
Source2: http://www.pobox.com/~jmknoble/software/x11-ssh-askpass/x11-ssh-askpass-%{aversion}.tar.gz
### High-Performance Networking (HPN) for SSH:  http://sourceforge.net/projects/hpnssh/
# Patch generated from https://github.com/rapier1/openssh-portable/ via https://github.com/mej/openssh-hpn-isshd
Patch100: openssh-%{version}-hpn.patch
Patch1000: openssh-%{version}-openssl_seeds_itself.patch
Patch1001: openssh-%{version}-use_pam.patch
Patch1002: openssh-%{version}-convert_hpn_logging_debug.patch
Patch1003: openssh-%{version}-maxsessions_warning.patch
Patch1004: openssh-%{version}-fix_visual_host_key_on_threaded_ctr_rekey.patch
Patch1005: openssh-%{version}-openssl_version_check_nonfatal.patch
Patch1006: openssh-%{version}-CVE_2016_0777_0778.patch
Patch1007: openssh-%{version}-default_permit_dsa.patch
%if %{nersc}
Patch900: openssh-%{version}-nersc_bro_isshd_3.17.patch
Patch9000: openssh-%{version}-nersc_bro_log_connect.patch
Patch9001: openssh-%{version}-nersc_complex_kex_fix.patch
Conflicts: openssh < %{version}-%{release}, openssh > %{version}-%{release}
Provides: openssh = %{version}-%{release}
%endif
#BuildSuggests: xauth tcp_wrappers tcp_wrappers-devel
%if %{gtk}
#BuildSuggests: gtk+-devel gtk-devel gtk1-devel
%if %{?__pkgconfig_requires:1}0
BuildRequires: pkgconfig(gtk+-2.0)
%else
BuildRequires: /usr/bin/gtk-config
%endif
%endif
BuildRequires: autoconf, openssl-devel, perl, zlib-devel, pam-devel
BuildRequires: /bin/login, /usr/include/tcpd.h, %{breq_xauth}
Obsoletes: ssh
Requires: /sbin/nologin
Requires: initscripts >= 5.20
%if ! %{no_x11_askpass}
#BuildSuggests: xorg-x11-devel XFree86-devel libX11-devel imake
BuildRequires: %{_includedir}/X11/Xlib.h %{breq_xmkmf}
%endif
%if ! %{no_gnome_askpass}
%if ! %{gtk}
BuildRequires: gnome-libs-devel
%endif
%endif
%if %{kerberos5}
BuildRequires: krb5-devel
%endif
BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot

%description
SSH (Secure SHell) is a program for logging into and executing
commands on a remote machine. SSH is intended to replace rlogin and
rsh, and to provide secure encrypted communications between two
untrusted hosts over an insecure network. X11 connections and
arbitrary TCP/IP ports can also be forwarded over the secure channel.

OpenSSH is OpenBSD's version of the last free version of SSH, bringing
it up to date in terms of security and features, as well as removing
all patented algorithms to separate libraries.

This package includes the core files necessary for both the OpenSSH
client and server. To make this package useful, you should also
install %{name}-clients, %{name}-server, or both.

%package clients
Summary: OpenSSH clients.
Group: Applications/Internet
Obsoletes: ssh-clients
Requires: %{name} = %{version}-%{release}
%if %{nersc}
Conflicts: openssh-clients < %{version}-%{release}, openssh-clients > %{version}-%{release}
Provides: openssh-clients = %{version}-%{release}
%endif

%description clients
OpenSSH is a free version of SSH (Secure SHell), a program for logging
into and executing commands on a remote machine. This package includes
the clients necessary to make encrypted connections to SSH servers.
You'll also need to install the openssh package on OpenSSH clients.

%package server
Summary: The OpenSSH server daemon.
Group: System Environment/Daemons
Obsoletes: ssh-server
Requires: chkconfig >= 0.9, /usr/sbin/useradd
Requires: /etc/pam.d/system-auth
%if %{nersc}
Conflicts: openssh-server < %{version}-%{release}, openssh-server > %{version}-%{release}
Provides: openssh-server = %{version}-%{release}
%endif

%description server
OpenSSH is a free version of SSH (Secure SHell), a program for logging
into and executing commands on a remote machine. This package contains
the secure shell daemon (sshd). The sshd daemon allows SSH clients to
securely connect to your SSH server. You also need to have the %{name}
package installed.

%package askpass
Summary: A passphrase dialog for OpenSSH and X.
Group: Applications/Internet
Requires: %{name} = %{version}-%{release}
Obsoletes: ssh-extras
%if %{nersc}
Conflicts: openssh-askpass < %{version}-%{release}, openssh-askpass > %{version}-%{release}
Provides: openssh-askpass = %{version}-%{release}
%endif

%description askpass
OpenSSH is a free version of SSH (Secure SHell), a program for logging
into and executing commands on a remote machine. This package contains
an X11 passphrase dialog for OpenSSH.

%package askpass-gnome
Summary: A passphrase dialog for OpenSSH, X, and GNOME.
Group: Applications/Internet
Requires: %{name} = %{version}-%{release}
Obsoletes: ssh-extras
%if %{nersc}
Conflicts: openssh-askpass-gnome < %{version}-%{release}, openssh-askpass-gnome > %{version}-%{release}
Provides: openssh-askpass-gnome = %{version}-%{release}
%endif

%description askpass-gnome
OpenSSH is a free version of SSH (Secure SHell), a program for logging
into and executing commands on a remote machine. This package contains
an X11 passphrase dialog for OpenSSH and the GNOME GUI desktop
environment.

%prep
%if ! %{no_x11_askpass}
%setup -q -a 2 -n openssh-%{version}
%else
%setup -q -n openssh-%{version}
%endif

### HPN patch
%patch100 -p1

### Our patches on top of HPN.
%patch1000 -p1
%patch1001 -p1
%patch1002 -p1
%patch1003 -p1
%patch1004 -p1
%patch1005 -p1
%patch1006 -p1
%patch1007 -p1

%if %{nersc}
### NERSC iSSHD patch
%patch900 -p1
### Our patches on top of NERSC iSSHD
%patch9000 -p1
%patch9001 -p1
%endif
autoconf
autoheader


%build
CFLAGS="$RPM_OPT_FLAGS -g3"; export CFLAGS
%if %{kerberos5}
PATH=/usr/kerberos/bin/:${PATH} krb5_prefix=`krb5-config --prefix`
if test "$krb5_prefix" != "%{_prefix}" ; then
	CPPFLAGS="$CPPFLAGS -I${krb5_prefix}/include -I${krb5_prefix}/include/gssapi"; export CPPFLAGS
	CFLAGS="$CFLAGS -I${krb5_prefix}/include -I${krb5_prefix}/include/gssapi"
	LDFLAGS="$LDFLAGS -L${krb5_prefix}/%{_lib}"; export LDFLAGS
else
	krb5_prefix=
	CPPFLAGS="-I%{_includedir}/gssapi"; export CPPFLAGS
	CFLAGS="$CFLAGS -I%{_includedir}/gssapi"
fi
%endif

%configure \
	--sysconfdir=%{_sysconfdir}/ssh \
	--libexecdir=%{_libexecdir}/openssh \
	--datadir=%{_datadir}/%{name} \
	--with-tcp-wrappers --without-zlib-version-check \
	--with-rsh=%{_bindir}/rsh \
	--with-default-path=/usr/local/bin:/bin:/usr/bin \
	--with-superuser-path=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin \
	--with-privsep-path=%{_var}/empty/sshd \
	--with-sshca-dir=/etc/sshd/ca --enable-ocsp --with-mantype=man \
%if %{kerberos5}
	--with-kerberos5${krb5_prefix:+=${krb5_prefix}} \
%else
	--without-kerberos5 \
%endif
%if %{nersc}
	--with-nerscmod --without-passwdrec \
%endif
	--with-ssh1 --with-smartcard --with-pam --disable-strip

%if %{static_libcrypto}
perl -pi -e "s|-lcrypto|%{_libdir}/libcrypto.a|g" Makefile
%endif
%{__make}

%if ! %{no_x11_askpass}
pushd x11-ssh-askpass-%{aversion}
# This configure can't handle platform strings.
./configure --prefix=%{_prefix} --libdir=%{_libdir} --libexecdir=%{_libexecdir}/openssh
xmkmf -a
make
popd
%endif

# Define a variable to toggle gnome1/gtk building.  This is necessary
# because RPM doesn't handle nested %if statements.
%if %{gtk}
	gtk=yes
%else
	gtk=no
%endif

%if ! %{no_gnome_askpass}
pushd contrib
if [ $gtk = yes ] ; then
	make gnome-ssh-askpass2
	mv gnome-ssh-askpass2 gnome-ssh-askpass
else
	make gnome-ssh-askpass1
	mv gnome-ssh-askpass1 gnome-ssh-askpass
fi
popd
%endif

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p -m755 $RPM_BUILD_ROOT%{_sysconfdir}/ssh
mkdir -p -m755 $RPM_BUILD_ROOT%{_libexecdir}/openssh
mkdir -p -m755 $RPM_BUILD_ROOT%{_var}/empty/sshd
make install DESTDIR=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT/etc/pam.d/
install -d $RPM_BUILD_ROOT/etc/rc.d/init.d
install -d $RPM_BUILD_ROOT%{_libexecdir}/openssh

if [ -d contrib/%{_vendor} ]; then
    %{__install} -m 0644 contrib/%{_vendor}/sshd.pam $RPM_BUILD_ROOT/etc/pam.d/sshd
    %{__install} -m 0755 contrib/%{_vendor}/sshd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/sshd
else
    %{__install} -m 0644 contrib/redhat/sshd.pam $RPM_BUILD_ROOT/etc/pam.d/sshd
    %{__install} -m 0755 contrib/redhat/sshd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/sshd
fi

# Fix for RHEL6
if [ -f /etc/pam.d/remote ]; then
    sed -e '/securetty/d' /etc/pam.d/remote > $RPM_BUILD_ROOT/etc/pam.d/sshd
fi

%if ! %{no_x11_askpass}
install x11-ssh-askpass-%{aversion}/x11-ssh-askpass $RPM_BUILD_ROOT%{_libexecdir}/openssh/x11-ssh-askpass
ln -s x11-ssh-askpass $RPM_BUILD_ROOT%{_libexecdir}/openssh/ssh-askpass
%endif

%if ! %{no_gnome_askpass}
install contrib/gnome-ssh-askpass $RPM_BUILD_ROOT%{_libexecdir}/openssh/gnome-ssh-askpass
%endif

%if ! %{scard}
	rm -f $RPM_BUILD_ROOT%{_datadir}/%{name}/Ssh.bin
%endif

%if ! %{no_gnome_askpass}
install -m 755 -d $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/
install -m 755 contrib/redhat/gnome-ssh-askpass.csh $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/
install -m 755 contrib/redhat/gnome-ssh-askpass.sh $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/
%endif

perl -pi -e "s|$RPM_BUILD_ROOT||g" $RPM_BUILD_ROOT%{_mandir}/man*/*

rm -rf $RPM_BUILD_ROOT%{_sysconfdir}/ssh/ssh_prng_cmds || :
rm -rf $RPM_BUILD_ROOT%{_libexecdir}/openssh/ssh-rand-helper || :
rm -rf $RPM_BUILD_ROOT%{_mandir}/man8/ssh-rand-helper.8.gz || :

%clean
rm -rf $RPM_BUILD_ROOT

%pre server
/usr/sbin/useradd -c "Privilege-separated SSH" -u 74 \
	-s /sbin/nologin -r -d /var/empty/sshd sshd 2> /dev/null || :

%post server
/sbin/chkconfig --add sshd

%postun server
/sbin/service sshd condrestart > /dev/null 2>&1 || :

%preun server
if [ "$1" = 0 ]
then
	/sbin/service sshd stop > /dev/null 2>&1 || :
	/sbin/chkconfig --del sshd
fi

%files
%defattr(-,root,root)
%doc CREDITS ChangeLog INSTALL LICENCE OVERVIEW PROTOCOL* *README* TODO
%attr(0755,root,root) %dir %{_sysconfdir}/ssh/
%attr(0755,root,root) %dir %{_libexecdir}/openssh/
%attr(0600,root,root) %config %{_sysconfdir}/ssh/moduli
%attr(0755,root,root) %{_bindir}/ssh-keygen
%attr(0644,root,root) %{_mandir}/man1/ssh-keygen.1*
%attr(4711,root,root) %{_libexecdir}/openssh/ssh-keysign
%attr(0755,root,root) %{_libexecdir}/openssh/ssh-pkcs11-helper
%attr(0644,root,root) %{_mandir}/man8/ssh-*.8*
#%attr(0755,root,root) %dir %{_datadir}/%{name}/
#%attr(0644,root,root) %{_datadir}/%{name}/Ssh.bin

%files clients
%defattr(-,root,root)
%attr(0755,root,root) %{_bindir}/ssh
%attr(0644,root,root) %{_mandir}/man1/ssh.1*
%attr(0755,root,root) %{_bindir}/scp
%attr(0644,root,root) %{_mandir}/man1/scp.1*
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/ssh/ssh_config
%attr(-,root,root) %{_bindir}/slogin
%attr(0644,root,root) %{_mandir}/man1/slogin.1*
%attr(0644,root,root) %{_mandir}/man5/moduli.5*
%attr(0644,root,root) %{_mandir}/man5/ssh_config.5*
%attr(2755,root,nobody) %{_bindir}/ssh-agent
%attr(0755,root,root) %{_bindir}/ssh-add
%attr(0755,root,root) %{_bindir}/ssh-keyscan
%attr(0755,root,root) %{_bindir}/sftp
%attr(0644,root,root) %{_mandir}/man1/ssh-agent.1*
%attr(0644,root,root) %{_mandir}/man1/ssh-add.1*
%attr(0644,root,root) %{_mandir}/man1/ssh-keyscan.1*
%attr(0644,root,root) %{_mandir}/man1/sftp.1*

%files server
%defattr(-,root,root)
%attr(0111,root,root) %dir %{_var}/empty/sshd/
%attr(0755,root,root) %dir %{_libexecdir}/openssh/
%attr(0600,root,root) %config %{_sysconfdir}/ssh/moduli
%attr(0755,root,root) %{_sbindir}/sshd
%attr(0755,root,root) %{_libexecdir}/openssh/sftp-server
%attr(0644,root,root) %{_mandir}/man5/sshd_config.5*
%attr(0644,root,root) %{_mandir}/man8/sshd.8*
%attr(0644,root,root) %{_mandir}/man8/sftp-server.8*
%attr(0600,root,root) %config(noreplace) %{_sysconfdir}/ssh/sshd_config
%attr(0600,root,root) %config(noreplace) /etc/pam.d/sshd
%attr(0755,root,root) %config /etc/rc.d/init.d/sshd

%if ! %{no_x11_askpass}
%files askpass
%defattr(-,root,root)
%doc x11-ssh-askpass-%{aversion}/README
%doc x11-ssh-askpass-%{aversion}/ChangeLog
%doc x11-ssh-askpass-%{aversion}/SshAskpass*.ad
%attr(0755,root,root) %{_libexecdir}/openssh/ssh-askpass
%attr(0755,root,root) %{_libexecdir}/openssh/x11-ssh-askpass
%endif

%if ! %{no_gnome_askpass}
%files askpass-gnome
%defattr(-,root,root)
%attr(0755,root,root) %config %{_sysconfdir}/profile.d/gnome-ssh-askpass.*
%attr(0755,root,root) %{_libexecdir}/openssh/gnome-ssh-askpass
%endif


%changelog
